package lib.ui;

import kernel.Log;
import util.Color;
import util.Vec.Vec2;
import util.MathI;

class TextElement implements IElement {
    private final text:String;
    private final bg:Color;
    private final fg:Color;

    public function new(text: String,?background: Color = Black,?textColor: Color = White) {
        this.text = text;
        this.bg = background;
        this.fg = textColor;
    }

	public function render(bounds: Vec2<Int>):Canvas {
		var rtn = new Canvas();

        for (i in 0...MathI.min(Math.floor(text.length / bounds.x) + 1,bounds.y)){
			var line = (text.substr(i * bounds.x,bounds.x));
            for (char in 0...line.length) {
                rtn.set({x: char,y: i},{textColor: fg,char: line.charAt(char),bg: bg});
            }
		}

        return rtn;
	}
}